
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>Hashing &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Grace mode and keep" href="vcl-grace.html" />
    <link rel="prev" title="Backend servers" href="vcl-backends.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="vcl-grace.html" title="Grace mode and keep"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="vcl-backends.html" title="Backend servers"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Users Guide</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="vcl.html" accesskey="U">VCL - Varnish Configuration Language</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Hashing</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="hashing">
<h1>Hashing<a class="headerlink" href="#hashing" title="Permalink to this headline">¶</a></h1>
<p>Internally, when Varnish stores content in the cache it stores the object
together with a hash key to find the object again. In the default setup
this key is calculated based on the content of the <em>Host</em> header or the
IP address of the server and the URL.</p>
<p>Behold the <cite>default vcl</cite>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">sub</span> <span class="n">vcl_hash</span> <span class="p">{</span>
    <span class="n">hash_data</span><span class="p">(</span><span class="n">req</span><span class="o">.</span><span class="n">url</span><span class="p">);</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">req</span><span class="o">.</span><span class="n">http</span><span class="o">.</span><span class="n">host</span><span class="p">)</span> <span class="p">{</span>
        <span class="n">hash_data</span><span class="p">(</span><span class="n">req</span><span class="o">.</span><span class="n">http</span><span class="o">.</span><span class="n">host</span><span class="p">);</span>
    <span class="p">}</span> <span class="k">else</span> <span class="p">{</span>
        <span class="n">hash_data</span><span class="p">(</span><span class="n">server</span><span class="o">.</span><span class="n">ip</span><span class="p">);</span>
    <span class="p">}</span>
    <span class="k">return</span> <span class="p">(</span><span class="n">lookup</span><span class="p">);</span>
<span class="p">}</span>
</pre></div>
</div>
<p>As you can see it first checks in <cite>req.url</cite> then <cite>req.http.host</cite> if
it exists. It is worth pointing out that Varnish doesn’t lowercase the
hostname or the URL before hashing it so in theory having “Varnish.org/”
and “varnish.org/” would result in different cache entries. Browsers
however, tend to lowercase hostnames.</p>
<p>You can change what goes into the hash. This way you can make Varnish
serve up different content to different clients based on arbitrary
criteria.</p>
<p>Let’s say you want to serve pages in different languages to your users
based on where their IP address is located. You would need some Vmod to
get a country code and then put it into the hash. It might look like this.</p>
<p>In <cite>vcl_recv</cite>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="nb">set</span> <span class="n">req</span><span class="o">.</span><span class="n">http</span><span class="o">.</span><span class="n">X</span><span class="o">-</span><span class="n">Country</span><span class="o">-</span><span class="n">Code</span> <span class="o">=</span> <span class="n">geoip</span><span class="o">.</span><span class="n">lookup</span><span class="p">(</span><span class="n">client</span><span class="o">.</span><span class="n">ip</span><span class="p">);</span>
</pre></div>
</div>
<p>And then add a <cite>vcl_hash</cite>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">sub</span> <span class="n">vcl_hash</span> <span class="p">{</span>
    <span class="n">hash_data</span><span class="p">(</span><span class="n">req</span><span class="o">.</span><span class="n">http</span><span class="o">.</span><span class="n">X</span><span class="o">-</span><span class="n">Country</span><span class="o">-</span><span class="n">Code</span><span class="p">);</span>
<span class="p">}</span>
</pre></div>
</div>
<p>As the default VCL will take care of adding the host and URL to the hash
we don’t have to do anything else. Be careful calling <code class="docutils literal notranslate"><span class="pre">return</span> <span class="pre">(lookup)</span></code>
as this will abort the execution of the default VCL and Varnish can end
up returning data based on more or less random inputs.</p>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="vcl-backends.html"
                        title="previous chapter">Backend servers</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="vcl-grace.html"
                        title="next chapter">Grace mode and keep</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/users-guide/vcl-hashing.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="vcl-grace.html" title="Grace mode and keep"
             >next</a> |</li>
        <li class="right" >
          <a href="vcl-backends.html" title="Backend servers"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Users Guide</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="vcl.html" >VCL - Varnish Configuration Language</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Hashing</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>